decodecode 2.18 KB
Newer Older
1
#!/bin/sh
2
# SPDX-License-Identifier: GPL-2.0
3 4 5 6 7 8 9
# Disassemble the Code: line in Linux oopses
# usage: decodecode < oops.file
#
# options: set env. variable AFLAGS=options to pass options to "as";
# e.g., to decode an i386 oops on an x86_64 system, use:
# AFLAGS=--32 decodecode < 386.oops

10
cleanup() {
11
	rm -f $T $T.s $T.o $T.oo $T.aa $T.dis
12 13 14 15 16 17 18 19 20 21 22
	exit 1
}

die() {
	echo "$@"
	exit 1
}

trap cleanup EXIT

T=`mktemp` || die "cannot create temp file"
23 24 25 26 27 28 29 30 31 32 33 34 35
code=

while read i ; do

case "$i" in
*Code:*)
	code=$i
	;;
esac

done

if [ -z "$code" ]; then
36
	rm $T
37 38 39 40 41 42
	exit
fi

echo $code
code=`echo $code | sed -e 's/.*Code: //'`

43
width=`expr index "$code" ' '`
44
width=$((($width-1)/2))
45 46 47 48 49 50 51
case $width in
1) type=byte ;;
2) type=2byte ;;
4) type=4byte ;;
esac

disas() {
52
	${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1
53

54 55
	if [ "$ARCH" = "arm" ]; then
		if [ $width -eq 2 ]; then
56 57 58 59 60 61 62
			OBJDUMPFLAGS="-M force-thumb"
		fi

		${CROSS_COMPILE}strip $1.o
	fi

	${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \
63
		grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1
64 65
}

66 67 68 69 70
marker=`expr index "$code" "\<"`
if [ $marker -eq 0 ]; then
	marker=`expr index "$code" "\("`
fi

71
touch $T.oo
72
if [ $marker -ne 0 ]; then
73 74 75
	echo All code >> $T.oo
	echo ======== >> $T.oo
	beforemark=`echo "$code"`
76 77 78 79 80
	echo -n "	.$type 0x" > $T.s
	echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s
	disas $T
	cat $T.dis >> $T.oo
	rm -f $T.o $T.s $T.dis
81 82 83 84

# and fix code at-and-after marker
	code=`echo "$code" | cut -c$((${marker} + 1))-`
fi
85 86
echo Code starting with the faulting instruction  > $T.aa
echo =========================================== >> $T.aa
87 88
code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'`
echo -n "	.$type 0x" > $T.s
89
echo $code >> $T.s
90 91
disas $T
cat $T.dis >> $T.aa
92

93 94 95 96 97 98
# (lines of whole $T.oo) - (lines of $T.aa, i.e. "Code starting") + 3,
# i.e. the title + the "===..=" line (sed is counting from 1, 0 address is
# special)
faultlinenum=$(( $(wc -l $T.oo  | cut -d" " -f1) - \
		 $(wc -l $T.aa  | cut -d" " -f1) + 3))

99
faultline=`cat $T.dis | head -1 | cut -d":" -f2-`
100
faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'`
101

102
cat $T.oo | sed -e "${faultlinenum}s/^\(.*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/"
103 104 105
echo
cat $T.aa
cleanup